#import "APAppticsExtension.h"

@implementation Apptics (Extension)

+ (void) setCustomEventsProtocol;{
	[APBundle getInstance].eventsProtocolClass=APEventExtension.class;
}

+ (void) setApiTrackingProtocol;{
	[APBundle getInstance].apiProtocolClass=APAPAPIExtension.class;
}

@end

@implementation APEvent (Extension)

+ (NSString*) eventID :(APEventType) type;{
	NSString *eventId;

	switch (type) {
		case APEventTypeNone:
			break;
		default:
			break;
	}
	return eventId;
}

+ (NSString*) groupID :(APEventType) type;{
	NSString *groupId;

	switch (type) {
		case APEventTypeNone:
			break;
		default:
			break;
	}
	return groupId;
}

+ (void) trackEventWithType:(APEventType) type;{
	[self trackEventWithType:type andProperties:nil];
}

+ (void) trackEventWithType:(APEventType) type andProperties:(NSDictionary*_Nullable)props;{
	NSString *eventID = [self eventID:type];
	NSString *groupID = [self groupID:type];
	[[APEvent getInstance] trackEvent:eventID groupId : groupID andProperties:props isTimed:false];
}

+ (void) startTimedEventWithType:(APEventType) type;{
	[self startTimedEventWithType:type andProperties:nil];
}

+ (void) startTimedEventWithType:(APEventType) type andProperties:(NSDictionary * _Nullable)props;{
	NSString *eventID = [self eventID:type];
	NSString *groupID = [self groupID:type];
	[[APEvent getInstance] trackEvent:eventID groupId : groupID andProperties:props isTimed:true];
}

+ (void) endTimedEventWithType:(APEventType) type;{
	NSString *eventID = [self eventID:type];
	[[APEvent getInstance] endTimedEvent:eventID];
}

@end

@implementation APEventExtension : NSObject

+ (APPrivateObject *)formatTypeToPrivateObject:(NSString*)group event : (NSString*) event {

	NSString* event_str=[[NSString stringWithFormat:@"%@_%@",group, event] lowercaseString];

		return nil;
}

+ (APPrivateObject *)formatTypeToPrivateObjectFromEventId:(NSString*)eventId{

		return nil;
}

@end

@implementation APAPAPIExtension : NSObject

+(BOOL) isMatchString : (NSString* ) source withString : (NSString*) pattern{
	NSRegularExpression *regex = [[NSRegularExpression alloc] initWithPattern:pattern options:0 error:nil];
	long n = [regex numberOfMatchesInString:source options:0 range:NSMakeRange(0, [source length])];
	return  (n > 0);
}

+(NSString*) directMatch : (NSString*) url{

		return nil;
}

+(NSString*) patternMatch : (NSString*) url{

		return nil;
}

@end
